
(function (mod){ //[HyperMD] UMD patched!
  /*commonjs*/  ("object"==typeof exports&&"undefined"!=typeof module) ? mod(null, exports, ) :
  /*amd*/       ("function"==typeof define&&define.amd) ? define(["require","exports"], mod) :
  /*plain env*/ mod(null, {}, );
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Themes = [
        {
            name: "light",
            editorTheme: "light",
            previewTheme: "github-light",
            codeBlockTheme: "github",
        },
        {
            name: "dark",
            editorTheme: "dark",
            previewTheme: "github-dark",
            codeBlockTheme: "monokai",
        },
    ];
    function setTheme(_a) {
        var editor = _a.editor, themeName = _a.themeName, _b = _a.baseUri, baseUri = _b === void 0 ? "./" : _b;
        var theme = exports.Themes.find(function (t) { return t.name === themeName; });
        if (!theme) {
            return;
        }
        // Set preview theme
        var previewThemeStyleElementID = "crossnote-preview-theme";
        var previewThemeStyleElement = document.getElementById(previewThemeStyleElementID);
        if (!previewThemeStyleElement) {
            previewThemeStyleElement = document.createElement("link");
            previewThemeStyleElement.id = previewThemeStyleElementID;
            previewThemeStyleElement.rel = "stylesheet";
            document.head.appendChild(previewThemeStyleElement);
        }
        previewThemeStyleElement.href =
            baseUri + ("preview_themes/" + theme.previewTheme + ".css");
        // Set code block theme
        var codeBlockThemeStyleElementID = "crossnote-code-block-theme";
        var codeBlockThemeStyleElement = document.getElementById(codeBlockThemeStyleElementID);
        if (!codeBlockThemeStyleElement) {
            codeBlockThemeStyleElement = document.createElement("link");
            codeBlockThemeStyleElement.id = codeBlockThemeStyleElementID;
            codeBlockThemeStyleElement.rel = "stylesheet";
            document.head.appendChild(codeBlockThemeStyleElement);
        }
        codeBlockThemeStyleElement.href =
            baseUri + ("prism_themes/" + theme.codeBlockTheme + ".css");
        // Set editor theme
        var editorThemeStyleElementID = "crossnote-editor-theme";
        var editorThemeStyleElement = document.getElementById(editorThemeStyleElementID);
        if (!editorThemeStyleElement) {
            editorThemeStyleElement = document.createElement("link");
            editorThemeStyleElement.id = editorThemeStyleElementID;
            editorThemeStyleElement.rel = "stylesheet";
            document.head.appendChild(editorThemeStyleElement);
        }
        editorThemeStyleElement.href =
            baseUri + ("editor_themes/" + theme.editorTheme + ".css");
        editor.setOption("theme", theme.editorTheme);
    }
    exports.setTheme = setTheme;
});
